
#include "V_M_UC.h"
#include "mem.h"
/*
* Allocate space for a copy of a null-terminated string, copy it to the new
* block, and return its address.  The m is for diagnostics.
*/
char* d_strdup(p,m)
	char *p, *m;
{	char *r=0;
	int   n;
	Fenter("d_strdup");

	if (!m) m = unknown;
	if (!p) {
		V2 "### Warning: called with null pointer." D;
		Fail;
	}
	n = strlen(p) + 1;
	n = MEMUNIT(n);
	V7M "Get %d bytes for \"%s\"",n,m D;
	if (r = (char*)GetChunk(n,m)) {

		Bcopy(p, r, n);
		V7M "Put %d bytes into %s.",n,m D;
	}
fail:
	Fexit;
	return r;
}
/*
* Here's a similar function that allows you to specify a length, which we will
* calculate if you send -1.  Note that we grab an extra byte and null-fill it.
*/
char* d_strdupn(p,n,m)
	char *p, *m;
	int   n;
{	char *r;
	Fenter("d_strdupn");
	if (!m) m = unknown;
	if (n < 0) n = strlen(p);
	if (r = (char*)GetChunk(MEMUNIT(n+1),m)) {

		Bcopy(p, r, n);
		p[n] = 0;	/* Null-terminate it */

	}
	Fexit;
	return r;
}
